/* Sistemas Integrados TECNISA
   
Nome: GERA_DATA.SQL

Descrio:
Insere datas em determinado perodo na tabela DATA.

P_DTINICIAL - Data inicial
P_DTFINAL   - Data final

@H:\SISTEMAS\DBA\SQL\ORACLE\0005_GERSTP_GERA_DATA.SQL

Criao:
11/12/98 - Ederson
*/

CREATE OR REPLACE
PROCEDURE GERA_DATA
  (P_DTINICIAL IN DATE,
   P_DTFINAL   IN DATE) IS

   V_DTAUXILIAR DATE;
   V_CONTAUXI   NUMBER;

BEGIN

   IF P_DTFINAL < P_DTINICIAL THEN
      raise_application_error(-20501, 'Data final deve ser maior ou igual a data inicial.', True);
   END IF;

   V_DTAUXILIAR := P_DTINICIAL;
   WHILE (V_DTAUXILIAR <= P_DTFINAL)   LOOP

       SELECT COUNT(*)
       INTO V_CONTAUXI
       FROM DATA
       WHERE (DTDATA = V_DTAUXILIAR);

       IF V_CONTAUXI = 0 THEN
          INSERT INTO
          DATA (DTDATA)
          VALUES (V_DTAUXILIAR);
       END IF;

       V_DTAUXILIAR := V_DTAUXILIAR + 1;
   END LOOP;

   UPDATE DATA 
      SET DTMES = TO_DATE('01'||TO_CHAR(DTDATA, 'MMYYYY'), 'DDMMYYYY')
   WHERE 
      DTMES IS NULL;

   COMMIT;
END;
/

BEGIN
   GERA_DATA(TO_DATE('01 01 1900', 'DD MM YYYY'), TO_DATE('31 12 2020', 'DD MM YYYY'));
END;
/